#
# spec file for package nouveau (Version 0.20070905)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# icecream 0
# usedforbuild    Mesa Mesa-devel aaa_base acl attr audit-libs autoconf automake bash binutils bzip2 coreutils cpio cpp cpp42 cracklib cvs diffutils file filesystem fillup findutils fontconfig fontconfig-devel fonts-config freetype2 freetype2-devel gawk gcc gcc42 gdbm gettext gettext-devel glib2 glib2-devel glibc glibc-devel glibc-locale glitz glitz-devel grep groff gzip info insserv kernel-source kernel-syms less libacl libattr libbz2-1 libbz2-devel libdb-4_5 libdrm libdrm-devel libexpat-devel libexpat1 libgcc42 libgomp42 libltdl-3 libmudflap42 libreadline5 libstdc++-devel libstdc++42 libstdc++42-devel libtool libuuid1 libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp module-init-tools ncurses net-tools netcfg pam pam-modules patch pcre pcre-devel perl perl-base permissions pkg-config popt rpm sed sysvinit tar texinfo timezone util-linux xorg-x11-devel xorg-x11-driver-video xorg-x11-fonts-core xorg-x11-fonts-devel xorg-x11-libICE xorg-x11-libICE-devel xorg-x11-libSM xorg-x11-libSM-devel xorg-x11-libX11 xorg-x11-libX11-devel xorg-x11-libXau xorg-x11-libXau-devel xorg-x11-libXdmcp xorg-x11-libXdmcp-devel xorg-x11-libXext xorg-x11-libXext-devel xorg-x11-libXfixes xorg-x11-libXfixes-devel xorg-x11-libXmu xorg-x11-libXmu-devel xorg-x11-libXp xorg-x11-libXp-devel xorg-x11-libXpm xorg-x11-libXpm-devel xorg-x11-libXprintUtil xorg-x11-libXprintUtil-devel xorg-x11-libXrender xorg-x11-libXrender-devel xorg-x11-libXt xorg-x11-libXt-devel xorg-x11-libXv xorg-x11-libXv-devel xorg-x11-libfontenc xorg-x11-libfontenc-devel xorg-x11-libs xorg-x11-libxcb xorg-x11-libxcb-devel xorg-x11-libxkbfile xorg-x11-libxkbfile-devel xorg-x11-proto-devel xorg-x11-server xorg-x11-server-sdk xorg-x11-util-devel xorg-x11-xtrans-devel zlib zlib-devel


Name:           nouveau
Url:            http://nouveau.freedesktop.org
License:        GPL v2 only; X11/MIT
Group:          System/Libraries
Summary:        Source code of the nouveau nVidia driver packages
Version:        0.20070905
Release:        1.1
Source:         %name-%version.tar.bz2
Patch1:         xf86-video-nouveau-linklocal.diff
Patch2:         xf86-video-nouveau-FP_TIMING.diff
Patch3:         xf86-video-nouveau-dpms_mode.diff
Patch4:         xf86-video-nouveau-set_modes.diff
Patch5:         xf86-video-nouveau-biostable.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  kernel-syms module-init-tools xorg-x11-server-sdk
# Only for the filelist:
BuildRequires:  xorg-x11-driver-video
Requires:       %name-kmp
ExclusiveArch:  %ix86 x86_64 ia64 ppc ppc64
%suse_kernel_module_package -n nouveau kdump um

%description
This package contains the source code of the nouveau nVidia driver
packages x11-video-nouveau and the accompanying nouveau-kmp packages
(e.g. nouveau-kmp-default) which contain the kernel modules for the 
installable kernel(s).

Only the 2D driver portion is included because (at the time of creation
of this package) the 3D driver has only highly experimental support for
flat shading (no textures, no lightning) on some nVidia chipsets which
means that only applications like glxgears could run accelerated in
this early phase.



%debug_package
%package -n x11-video-nouveau
License:        X11/MIT
Summary:        Nouveau X11 driver for nVidia cards (very experimental)
Group:          System/Libraries
Conflicts:      x11-video-nvidia x11-video-nvidiaG01
# Needed by nouveau-debuginfo, we could consider a rename of the spec to
# x11-video-nouveau now that I use '-n nouveau' in the kernel macro above,
# OTOH, nouveau-debuginfo also has the debug files for the kernel modules,
# also have to test if debugging nouveau_drv.so is working:
Provides:       nouveau

%description -n x11-video-nouveau
This package contains the experimental Nouveau driver for nVidia cards.

This package only provides the 2D driver portion because (at the time
of creation of this package) the 3D driver has only highly experimental
support for flat shading (no textures, no lightning) on some nVidia
chipsets which means that only applications like glxgears could run in
this early phase.



%package KMP
License:        GPL v2 only; X11/MIT
Summary:        Kernel modules for the nouveau X11 driver for nVidia cards (experimental)
Group:          System/Kernel

%description KMP
This package contains the kernel modules which are required by the
nouveau driver for nVidia cards as included in x11-video-nouveau.



%prep
: 'To create an updated source tarball using git clone, use:
version=0.`date +%Y%m%d`
mkdir nouveau-$version
cd nouveau-$version
git clone git://anongit.freedesktop.org/git/mesa/drm/
git clone git://anongit.freedesktop.org/git/nouveau/xf86-video-nouveau/
cd ..
tar cvfj nouveau-$version.tar.bz2 nouveau-$version --exclude .git
'
%setup -q -n %{name}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
cd drm
# We need explicit -fPIC here beccause we link the static libdrm.a into the shared nouveau_drv.so:
CFLAGS="$RPM_OPT_FLAGS -fPIC" \
./autogen.sh --prefix=/ --enable-static --disable-shared
cd ../xf86-video-nouveau
CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" ./autogen.sh --prefix=%_prefix --libdir=%_libdir

%build
# kernel modules
pushd drm
export EXTRA_CFLAGS="-DVERSION=%version"
for flavor in %flavors_to_build; do
    rm -rf $flavor
    cp -r linux-core $flavor
    make -C $flavor LINUXDIR=/usr/src/linux-obj/%_target_cpu/$flavor nouveau.o M=$PWD/$flavor
done
make install DESTDIR=$PWD/out
cd ../xf86-video-nouveau
make

%install
# kernel modules
pushd drm
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=weak-updates # needed because nouveau needs the drm.ko from nouveau's git tree
for flavor in %flavors_to_build; do
    make -C $flavor LINUXDIR=/usr/src/linux-obj/%_target_cpu/$flavor install M=$PWD/$flavor
done
cd ../xf86-video-nouveau
make DESTDIR=%{buildroot} install
%define ddxdir %_prefix/%_lib/xorg/modules/drivers

%files -n x11-video-%name
%defattr(-,root,root)
%{ddxdir}/%{name}_drv.so
%_mandir/man4/%{name}.4.gz
%exclude %{ddxdir}/%{name}_drv.la

%changelog
* Wed Sep 05 2007 - bk@suse.de
- switch to master branch, use Option "Randr12" to enable dual-head
- my fixes have been merged to master partly and patches are updated
* Mon Sep 03 2007 - bk@suse.de
- use randr-1.2 branch (dual lhead) and add fixes for DPMS, VT switch and Xv
* Fri Aug 31 2007 - bk@suse.de
- initial version from current git tree with libdrm built-in
